#ifndef API_CLIENT_H_
#define API_CLIENT_H_

#include <api/config.h>

#include <atomic>
#include <deque>
#include <map>
#include <string>
#include <core/net/http/request.h>
#include <core/net/uri.h>

#include <QXmlStreamReader>

namespace api {

class Client {
public:
    Client();

    virtual ~Client() = default;

    struct NewsItem {
        std::string title;
        std::string description;
        std::string image;
        std::string link;
        std::string category;
    };

    typedef std::deque<NewsItem> NewsList;

    NewsList allNews(const std::string &prefix, const std::string &department, const std::string &query);
    void cancel();

protected:
    void getSpiegelFeed(const std::string &path, QXmlStreamReader &reader);

    core::net::http::Request::Progress::Next progress_report(
            const core::net::http::Request::Progress& progress);

    std::atomic<bool> cancelled_;
};

}

#endif // API_CLIENT_H_

