#include <scope/preview.h>

#include <unity/scopes/ColumnLayout.h>
#include <unity/scopes/PreviewWidget.h>
#include <unity/scopes/PreviewReply.h>
#include <unity/scopes/Result.h>
#include <unity/scopes/VariantBuilder.h>

#include <iostream>

namespace sc = unity::scopes;

using namespace std;
using namespace scope;

Preview::Preview(const sc::Result &result, const sc::ActionMetadata &metadata) :
    sc::PreviewQueryBase(result, metadata) {
}

void Preview::cancelled() {
}

void Preview::run(sc::PreviewReplyProxy const& reply) {
    sc::ColumnLayout layout(1);
    layout.add_column( { "image", "header", "summary", "open" });

    reply->register_layout( { layout });
    sc::PreviewWidget header("header", "header");
    header.add_attribute_mapping("title", "title");

    sc::PreviewWidget image("image", "image");
    image.add_attribute_mapping("source", "art");

    sc::PreviewWidget description("summary", "text");
    description.add_attribute_mapping("text", "description");

    sc::PreviewWidget button("open", "actions");
    sc::VariantBuilder builder;
    builder.add_tuple({
        {"id", sc::Variant("open")},
        {"label", sc::Variant("Open")}
    });
    button.add_attribute_value("actions", builder.end());

    reply->push( { image, header, description, button });
}

